/**
 * UI design View

 */

import React from 'react';
import Container from '../../components/Container';
import { connect } from 'react-redux';
import {
    actions,
	components,
} from 'kadm-component';

import {
	Alert,
    Layout,
    Row,
    Col,
} from 'antdlib'
const { Header, Content } = Layout;
import PropTypes from 'prop-types'
var {
	Loading,
} = components.utilsForReactDom;
var ContentHeader = components.ContentHeader;
var {
	selectModel,
} = actions.lists;
import SiderMenu from './components/SiderMenu';

class DesignView extends React.Component{
	constructor(props){
		super(props)
		this.displayName = 'DesignView',
		this.contextTypes = {
			router: PropTypes.object.isRequired,
		}
	}
	getInitialState () {
		return {
		};
	}
	componentWillMount () {
		this.props.dispatch(selectModel(this.props.match.params.model));
	}
	componentWillReceiveProps (nextProps) {
		// We've opened a new item from the client side routing, so initialize
		// again with the new item id
		
	}
	// Initialize an item
	initializeItem (itemId) {
	}
	renderGrid(){
        let rowlist = [];
        for (var y = 0; y < 10; y++){
            let childrens = [];
            
            for (var x = 0; x < 24; x++){
                childrens.push(
                    <Col key={x} span={1} className="kadm-design-col" >{x + ":" + y}</Col>
                )
            }
            rowlist.push( 
                <Row key={y} gutter={15}>
                    {childrens}
                </Row>
            )
        }
        return rowlist;
    }
	render () {
		// If we don't have any data yet, show the loading indicator
		
		// When we have the data, render the item view with it

		

		return (
			<Layout>
				<Header className="content-header">
					<ContentHeader/>
				</Header>
				<Content className="page-content" style={{ margin: '0 16px', padding: 24, minHeight: 280 }}>
				
					<Layout>
						<Header style={{
							background:'#fff',
							marginBottom:30,
							display:'none',//not display now
						}}>
							
						</Header>
						<Layout>
							<SiderMenu style={{ background: '#fff' }} modules={this.props.modules} params={this.props.match.params} onNodeSelected={this.onNodeSelected} model={this.treeModel}/>
							
							<Content style={{
								// marginLeft:30,
							}}>
								{(this.props.error) ? this.handleError(this.props.error) : (
									<div>
										<Container>
											{this.renderGrid()}
											{/* {JSON.stringify(this.props.currentModel)} */}
										</Container>
									</div>
								)}
							</Content>
						</Layout>
					</Layout>
				</Content>
			</Layout>

		);
	}
};
export {
	DesignView
}
export default connect((state) => ({
	currentModel: state.lists.currentModel,
}))(DesignView);
