/**
 * Render a footer for a popout
 */

import React from 'react';
import PropTypes from 'prop-types'
const BUTTON_BASE_CLASSNAME = 'Popout__footer__button Popout__footer__button--';
import {
	Button
} from 'antdlib'
var createReactClass = require('create-react-class');
const PopoutFooter = createReactClass({
	displayName: 'PopoutFooter',
	propTypes: {
		children: PropTypes.node,
		primaryButtonAction: PropTypes.func,
		primaryButtonIsSubmit: PropTypes.bool,
		primaryButtonLabel: PropTypes.string,
		secondaryButtonAction: PropTypes.func,
		secondaryButtonLabel: PropTypes.string,
	},
	// Render a primary button
	renderPrimaryButton () {
		if (!this.props.primaryButtonLabel) return null;

		return (
			<Button
				type="primary"
				className={BUTTON_BASE_CLASSNAME + 'primary'}
				htmlType={this.props.primaryButtonIsSubmit && "submit"}
				onClick={this.props.primaryButtonAction}
			>
				{this.props.primaryButtonLabel}
			</Button>
		);
	},
	// Render a secondary button
	renderSecondaryButton () {
		if (!this.props.secondaryButtonAction || !this.props.secondaryButtonLabel) return null;

		return (
			<Button
				type="default"
				className={BUTTON_BASE_CLASSNAME + 'secondary'}
				onClick={this.props.secondaryButtonAction}
			>
				{this.props.secondaryButtonLabel}
			</Button>
		);
	},
	render () {
		return (
			<div className="Popout__footer">
				{this.renderPrimaryButton()}
				{this.renderSecondaryButton()}
				{this.props.children}
			</div>
		);
	},
});

module.exports = PopoutFooter;
