/**
 * Render a header for a popout
 */

import React from 'react';
import {
	CSSTransition,
	TransitionGroup
} from 'react-transition-group';
import PropTypes from 'prop-types'
import {
	Button
} from 'antdlib'
import _ from 'lodash';
var createReactClass = require('create-react-class');
const PopoutHeader = createReactClass({
	displayName: 'PopoutHeader',
	
	propTypes: {
		leftAction: PropTypes.func,
		leftIcon: PropTypes.string,
		title: PropTypes.string.isRequired,
		transitionDirection: PropTypes.oneOf(['next', 'prev']),
	},
	render () {
		// If we have a left action and a left icon, render a header button
		var headerButton = (this.props.leftAction && this.props.leftIcon) ? (
			<Button
				key={'button_' + this.props.transitionDirection}
				type="button"
				className={'Popout__header__button'}
				icon={this.props.leftIcon}
				onClick={this.props.leftAction}
			/>
		) : null;
		// If we have a title, render it
		var headerTitle = this.props.title ? (
			<span
				key={'title_' + this.props.transitionDirection}
				className="Popout__header__label"
			>
				{this.props.title}
			</span>
		) : null;

		return (
			<div className="Popout__header">
				<TransitionGroup>
					<CSSTransition
						in={ this.props.transitionDirection == 'next' }
						key={'button-' + this.props.transitionDirection}
						classNames="react-transitiongroup-fade"
						mountOnEnter
						unmountOnExit
					>
						<div>{headerButton}</div>
						
					</CSSTransition>

					<CSSTransition
							key={'title-' + this.props.transitionDirection}
							classNames={'Popout__pane-' + this.props.transitionDirection}
							mountOnEnter
							unmountOnExit
							addEndListener={(node, done) => {
								// use the css transitionend event to mark the finish of a transition
								node.addEventListener('transitionend', done, false);
							  }}
						>
							<div key={'div-' + this.props.transitionDirection}>{headerTitle}</div>
					</CSSTransition>

					{/* {
						_.map(['next','prev'], (o) => {
							
							return <CSSTransition
								key={'title-' + o}
								in={ this.props.transitionDirection == o }
								classNames={'Popout__pane-' + o}
								appear
								mountOnEnter
								unmountOnExit
							>
								<div>{headerTitle}</div>
							</CSSTransition>
						})
					} */}
				</TransitionGroup>
				
			</div>
		);
	},
});

module.exports = PopoutHeader;
