/**
 * Render a popout pane, calls props.onLayout when the component mounts
 */

import React from 'react';
import blacklist from 'blacklist';
import classnames from 'classnames';
import PropTypes from 'prop-types'
var createReactClass = require('create-react-class');
var PopoutPane = createReactClass({
	displayName: 'PopoutPane',
	propTypes: {
		children: PropTypes.node.isRequired,
		className: PropTypes.string,
		onLayout: PropTypes.func,
	},
	getDefaultProps () {
		return {
			onLayout: () => {},
		};
	},
	componentDidMount () {
		this.props.onLayout(this.refs.el.offsetHeight);
	},
	render () {
		const className = classnames(this.props.className);
		const props = blacklist(this.props, 'className', 'onLayout');

		return (
			<div ref="el" className={className} {...props} />
		);
	},
});

module.exports = PopoutPane;
