/**
 * Renders an Alert. Pass either an isInvalid and invalidMessage prop, or set
 * the signedOut prop to true to show the standard signed out message
 */

import React from 'react';
import {Alert} from 'antdlib';
import PropTypes from 'prop-types'
const AlertView = function (props) {
	if (props.isInvalid) {
		return <Alert key="error" type="danger" showIcon closable message={props.invalidMessage}/>;
	} else if (props.signedOut) {
		return <Alert key="signed-out" type="info" showIcon closable message="成功登出"/>;
	} else {
		// Can't return "null" from stateless components
		return <span />;
	}
};

AlertView.propTypes = {
	invalidMessage: PropTypes.string,
	isInvalid: PropTypes.bool,
	signedOut: PropTypes.bool,
};

module.exports = AlertView;
