/**
 * The login form of the signin screen
 */

import React from 'react';
import PropTypes from 'prop-types'
import {
	Button,
	Form,
	Input,
} from 'antdlib';

const LoginForm = ({
	email,
	handleInputChange,
	handleSubmit,
	isAnimating,
	password,
}) => {
	return (
		<div className="auth-box__col">
			<Form onSubmit={handleSubmit}>
				<Form.Item label="Email" htmlFor="email">
					<Input
						size='large'
						autoFocus
						type="email"
						name="email"
						onChange={handleInputChange}
						value={email}
					/>
				</Form.Item>
				<Form.Item  label="Password" htmlFor="password">
					<Input
						size='large'
						type="password"
						name="password"
						onChange={handleInputChange}
						value={password}
					/>
				</Form.Item >
				<Button type="primary" size='large' htmlType="submit">
					登录
				</Button>
			</Form>
		</div>
	);
};

LoginForm.propTypes = {
	email: PropTypes.string,
	handleInputChange: PropTypes.func.isRequired,
	handleSubmit: PropTypes.func.isRequired,
	isAnimating: PropTypes.bool,
	password: PropTypes.string,
};


module.exports = LoginForm;
