import React from 'react';
import SegmentedControl from '../../components/SegmentedControl';
import PropTypes from 'prop-types'
const VALUE_OPTIONS = [
	{ label: '已选中', value: true },
	{ label: '未选中', value: false },
];

function getDefaultValue () {
	return {
		value: true,
	};
}

var createReactClass = require('create-react-class');
var BooleanFilter = createReactClass({
	propTypes: {
		filter: PropTypes.shape({
			value: PropTypes.bool,
		}),
	},
	statics: {
		getDefaultValue: getDefaultValue,
	},
	getDefaultProps () {
		return {
			filter: getDefaultValue(),
		};
	},
	updateValue (value) {
		this.props.onChange({ value });
	},
	render () {
		return <SegmentedControl equalWidthSegments options={VALUE_OPTIONS} defaultValue={this.props.filter.value} onChange={this.updateValue} />;
	},
});

module.exports = BooleanFilter;
