import React from 'react';

import { SegmentedControl } from 'elemental';
import PropTypes from 'prop-types'
const OPTIONS = [
	{ label: 'Is Set', value: true },
	{ label: 'Is NOT Set', value: false },
];

function getDefaultValue () {
	return {
		exists: true,
	};
}

var createReactClass = require('create-react-class');
var CloudinaryImageFilter = createReactClass({
	propTypes: {
		filter: PropTypes.shape({
			exists: PropTypes.oneOf(OPTIONS.map(i => i.value)),
		}),
	},
	statics: {
		getDefaultValue: getDefaultValue,
	},
	getDefaultProps () {
		return {
			filter: getDefaultValue(),
		};
	},
	toggleExists (value) {
		this.props.onChange({ exists: value });
	},
	render () {
		const { filter } = this.props;

		return (
			<SegmentedControl
				equalWidthSegments
				onChange={this.toggleExists}
				options={OPTIONS}
				value={filter.exists}
			/>
		);
	},
});

module.exports = CloudinaryImageFilter;
