import React from 'react';
import _ from 'lodash';
import {
	Link,
} from 'react-router-dom';
import ItemsTableCell from '../../components/ItemsTableCell';
import ItemsTableValue from '../../components/ItemsTableValue';
import {
	Button,
	Tooltip,
} from 'antdlib';
import path from 'path'
import PropTypes from 'prop-types'
var createReactClass = require('create-react-class');
var ControlColumn = createReactClass({
	displayName: 'ControlColumn',
	propTypes: {
		col: PropTypes.object,
		data: PropTypes.object,
	},
	renderValue () {
		var btns = _.map(this.props.controls, (o) => {

			
			return <Tooltip key={o.icon} placement="bottom" title={o.label}>
						<Link to={path.join(o.url, this.props.data.id)}>
							<Button key={o.icon} size="small" type="primary" ghost icon={o.icon} style={{
								border:'none',
							}}/>
						</Link> 
					</Tooltip>
		});
		return (
			<ItemsTableValue truncate={false} field={this.props.col.type}>
				<Button.Group>
					{btns}
				</Button.Group>
			</ItemsTableValue>
		);
	},
	render () {
		return (
			<ItemsTableCell>
				{this.renderValue()}
			</ItemsTableCell>
		);
	},
});

module.exports = ControlColumn;
