/**
TODO:
- Format size of stored file (if present) using bytes package?
- Display file type icon? (see LocalFileField)
*/
import PropTypes from 'prop-types'
import Field from '../Field';
import React from 'react';
import _ from 'lodash';
import {
	Input,
	Upload,
	Icon,
	Modal,
} from 'antdlib';
const Dragger = Upload.Dragger;


/**
 *
 * props use in model
 *
 * listType: "text", "picture", "picture-card", //see that antd design in upload
 *
 *
 */


let FileField = Field.create({

	propTypes: {
		listType: PropTypes.string,
	},
	getInitialState(){
		return {
			previewVisible: false,
			previewImage: '',
			fileList:[],
		}
	},
	getInitialProps(){
		return {
			fieldType:"all",
			limit:5,
		}
	},
	handlePreview(file){
		this.setState({
		  previewImage: file.url || file.thumbUrl,
		  previewVisible: true,
		  fileList:[],
		});
	},
	handleCancel(){
		this.setState({ previewVisible: false });
	},
	handleAvatarBeforeUpload(file){
		const isPic = file.type === 'image/jpeg' || file.type === 'image/png';
		if (!isPic) {
			message.error('You can only upload pic file!');
		}
		const isLt2M = file.size / 1024 / 1024 < 2;
		if (!isLt2M) {
			message.error('Image must smaller than 2MB!');
		}
		return isPic && isLt2M;
	},
	handleBeforeUpload(file, fileList){
		var fileListNow = this.props.form.getFieldValue(this.getInputName(this.props.path)) || [];
		if (fileList.length + fileListNow.length > this.props.limit && this.props.limit > 0) return false;
		return true;
	},
	handleAvatarChange(info){
		// var file = this.props.form.getFieldValue(this.getInputName(this.props.path)) || [];
		const status = info.file.status;
		let obj = info.file;
		if (obj.status === 'done'){
			obj = _.assign({}, obj, obj.response.info.result);
		}
		this.props.form.setFieldsValue({
			[this.getInputName(this.props.path)]:[obj],
		})
		
	},
	handlePictureWallChanged(info) {
		var fileList = this.props.form.getFieldValue(this.getInputName(this.props.path)) || [];
		const status = info.file.status;
		switch (status){
			case "uploading":
			{
				if (info.fileList.length > fileList.length){
					fileList.push(_.assign({}, info.file, {
						status:'uploading',
					}));
				}
				let obj = fileList[fileList.length - 1];
				_.assign(obj, info.file, {
					status:'uploading',
					name:obj.name,
					// url: 'https://zos.alipayobjects.com/rmsportal/jkjgkEfvpUPVyRjUImniVslZfWPnJuuZ.png',
						
				})
				// obj = _.pick(obj, ['name', 'uid', 'status', 'url','percent'  ]);
				// fileList[fileList.length - 1] = obj;
				this.props.form.setFieldsValue({
					[this.getInputName(this.props.path)]:[].concat(fileList),
				});
			}
				break;
			case "done":
				{
					let obj = fileList[fileList.length - 1];
					let res = info.file;
					if (info.file.response){
						_.assign(obj, info.file.response.info.result, {
							uid:info.file.uid,
							lastModified:info.file.lastModified,
							name:obj.name,
						});
						// _.assign(obj, {
						// 	status: 'uploading',
						// 	percent:30.0,
						// 	url: 'https://zos.alipayobjects.com/rmsportal/jkjgkEfvpUPVyRjUImniVslZfWPnJuuZ.png',
						//   });
						this.props.form.setFieldsValue({
							[this.getInputName(this.props.path)]:[].concat(fileList),
						});
					}
					else {
						_.assign(obj, info.file, {
							status:'uploading',
							name:obj.name,
							// url: 'https://zos.alipayobjects.com/rmsportal/jkjgkEfvpUPVyRjUImniVslZfWPnJuuZ.png',
						});
						// obj = _.pick(obj, ['name', 'uid', 'status', 'url','percent' ]);
						// fileList[fileList.length - 1] = obj;
						this.props.form.setFieldsValue({
							[this.getInputName(this.props.path)]:[].concat(fileList),
						});
					}
					console.log(res);
				}
				break;
			case "removed":
			{
				
				var fileList = this.props.form.getFieldValue(this.getInputName(this.props.path)) || [];
				_.remove(fileList, (o) => {
					return o.uid == info.file.uid;
				})
				this.props.form.setFieldsValue({
					[this.getInputName(this.props.path)]:fileList,
				});
				
			}
			break;
			default:

		}
		this.props.form.setFieldsValue({
			[this.getInputName(this.props.path)]:fileList,
		})
	},
	handleFieldAllChanged(info){
		/**
		 * upload response text
		 *
		 * error
		 :
		 undefined
		 lastModified
		 :
		 1509353311000
		 lastModifiedDate
		 :
		 Mon Oct 30 2017 16:48:31 GMT+0800 (CST) {}
		 name
		 :
		 "车联网登录end.jpg"
		 originFileObj
		 :
		 File {uid: "rc-upload-1510631707626-2", name: "车联网登录end.jpg", lastModified: 1509353311000, lastModifiedDate: Mon Oct 30 2017 16:48:31 GMT+0800 (CST), webkitRelativePath: "", …}
		 percent
		 :
		 100
		 response
		 :
		 {status: 1, info: {…}}
		 size
		 :
		 102531
		 status
		 :
		 "done"
		 type
		 :
		 "image/jpeg"
		 uid
		 :
		 "rc-upload-1510631707626-2"
		 *
		 *
		 */
		const status = info.file.status;
		switch (status){
			case "done":
				var fileList = this.props.form.getFieldValue(this.getInputName(this.props.path)) || [];
				let value = _.assign({}, info.file.response.info.result, {
					uid:info.file.uid,
					lastModified:info.file.lastModified
				});
				fileList.push(value);
				this.props.form.setFieldsValue({
					[this.getInputName(this.props.path)]:fileList,
				});
				break;
			case "removed":
				var fileList = this.props.form.getFieldValue(this.getInputName(this.props.path)) || [];
				_.remove(fileList, (o) => {
					return o.uid == info.file.uid;
				})
				this.props.form.setFieldsValue({
					[this.getInputName(this.props.path)]:fileList,
				});
				break;
			default:
				break;
		}

	},
	format(){
		var value = this.props.form.getFieldValue(this.getInputName(this.props.path));
		return JSON.stringify(value);
	},
	shouldUseFieldDecorator(){
		return false;
	},
	renderFieldAvatar(value){
		
		const uploadButton = (
			<div>
			  <Icon type={this.state.loading ? 'loading' : 'plus'} />
			  <div className="ant-upload-text">Upload</div>
			</div>
		  );
		  value = value.length > 0 ? value[0] : {}
		  const imageUrl = value.thumbUrl || value.url;
		  var uploadProps = {
			name: 'file',
			multiple: true,
			showUploadList: false,
			className:"avatar-uploader",
			action: '/admin/api2/upload/',// + this.props.belongModel,
			// action:'//jsonplaceholder.typicode.com/posts/',
			headers:{
				"x-csrf-token":KAdm.csrf.header["x-csrf-token"],
			},
			data:{
				uploadPath:this.props.uploadPath || "",
				schema:JSON.stringify(this.props.schema)
			},
			listType:'picture-card',
			onChange:this.handleAvatarChange,
			beforeUpload:this.handleAvatarBeforeUpload,
		}
		  return (
			<Upload
			  {...uploadProps}
			>
			  {imageUrl ? <img src={imageUrl} style={{
				  maxWidth:400,
			  }} alt="avatar" /> : uploadButton}
			</Upload>
		  );
	},
	renderFieldPictureWall(value){
		const uploadButton = (
			<div>
			  <Icon type={this.state.loading ? 'loading' : 'plus'} />
			  <div className="ant-upload-text">Upload</div>
			</div>
		  );
		var uploadProps = {
			name: 'file',
			multiple: true,
			showUploadList: true,
			action: '/admin/api2/upload/',// + this.props.belongModel,
			// action:'//jsonplaceholder.typicode.com/posts/',
			headers:{
				"x-csrf-token":KAdm.csrf.header["x-csrf-token"],
			},
			data:{
				uploadPath:this.props.uploadPath || "",
				schema:JSON.stringify(this.props.schema)
			},
			listType:'picture-card',
			onChange:this.handlePictureWallChanged,
			// beforeUpload:this.handleBeforeUpload,
		}
		// TODO work here
		return (
			<div className="clearfix">
				<Upload
				{...uploadProps}
				fileList={value}
				onPreview={this.handlePreview}
				>
				{value.length >= this.props.limit ? null : uploadButton}
				</Upload>
				<Modal visible={this.state.previewVisible} footer={null} onCancel={this.handleCancel}>
				<img alt="example" style={{ width: '100%' }} src={this.state.previewImage} />
				</Modal>
			</div>
		);
	},
	renderFieldModeAll(value){
		var uploadProps = {
			name: 'file',
			multiple: true,
			showUploadList: true,
			action: '/admin/api2/upload/',// + this.props.belongModel,
			defaultFileList:value,
			headers:{
				"x-csrf-token":KAdm.csrf.header["x-csrf-token"],
			},
			data:{
				uploadPath:this.props.uploadPath || "",
				schema:JSON.stringify(this.props.schema)
			},
			listType:'picture',
			onChange:this.handleFieldAllChanged,
			beforeUpload:this.handleBeforeUpload,
		}
		return (
			<Dragger {...uploadProps}>
				<p className="ant-upload-drag-icon">
					<Icon type="inbox" />
				</p>
				<p className="ant-upload-text">点击或拖动文件到这里进行上传</p>
				<p className="ant-upload-hint">支持多个文件上传. </p>
			</Dragger>
		);
	},
	renderField(){
		const {   path} = this.props;
		const { getFieldDecorator } = this.props.form;

		let node = getFieldDecorator(
			path,
			{
				rules: this.getValidateRules(),
				initialValue:this.getInitValue(),
			}
		)(
				<Input
					{...{

						type:"hidden",
						name:this.getInputName(this.props.path)
					}}
				/>
		)

		var value = this.props.form.getFieldValue(this.getInputName(this.props.path));
		// var value = _.map(fileList, function(o){
		// 	return {
		// 		// uid: -1,
		// 		// name: 'xxx.png',
		// 		// status: 'done',
		// 		// url: 'http://www.baidu.com/xxx.png',
		// 		uid:o.uid,
		// 		name:o.name,
		// 		url:o.url,
		// 	}
		// })
		// var value = this.state.fileList;

		let renderMethod; 
		switch(this.props.fileType){
			case 'all':
				renderMethod = this.renderFieldModeAll;
				break;

			case 'picture-wall':
				renderMethod = this.renderFieldPictureWall;
				break;

			case 'avatar':
				renderMethod = this.renderFieldAvatar;
				break;
		}
		return (
			<div style={{ marginTop: 16 }}>
				{renderMethod(value)}
				{node}
			</div>
		);
		
		
	}
});
module.exports = FileField;

