import Field from '../Field';
import React from 'react';
import _ from 'lodash';
import URL from 'url';

/**
 * TODO:
 * - Custom path support
 */
import {
	Select,
	Input,
	Card,
	Row,
	Col,
	Icon,
	Button,
	Table,
	InputNumber,
	Form,
} from "antdlib";
import Propertys from './propertys'
const Option = Select.Option;
module.exports = Field.create({

	displayName: 'GoodPropertyMarixField',
	statics: {
		type: 'GoodPropertyMarix',
	},
	getInitialState () {
		
		// return {
		// 	propertyMap:[
		// 		{
		// 			propertyName:'规格名',
		// 			values:['规格1','规格2']
		// 		},
		// 		{
		// 			propertyName:'规格名2',
		// 			values:['规格11','规格12']
		// 		},
		// 		{
		// 			propertyName:'规格名2',
		// 			values:['规格11','规格12']
		// 		},
		// 	],
		// 	marixValue:[{
		// 		propertyList:['规格1', '规格11', '规格111'],
		// 		price:0,
		// 		store:0,
		// 	}]
		// }
		
		
		return {
			propertyMap:[],
			marixValue:[]
		};
	},
	shouldUseFieldDecorator(){
		return false;
	},
	getValidateRules(){
		return [{ validator:(rule, value, cb) => {
			
			let keys = _.keys(this.state.validateResult);
			if (keys.length > 0)
				return cb('需要修正提示错误');
			return cb();
		}}];
	},
	format(){
		let data = this.getFormFieldValue()
		return data ? JSON.stringify(data) : null;
	},
	validateValues(){
		let data = this.getFormFieldValue();
		let validateResult = {};
		
		_.forEach(data.propertyMap, (o) => {
			let duplicates = [];
			_.forEach(o.values, (value, index) => {
				if(_.indexOf(o.values,value) != _.lastIndexOf(o.values,value))
					duplicates.push(value);
				
			});
			
			if (duplicates.length > 0){
				//重复，找出重复元素
				validateResult = _.assign(validateResult, {
					[o.propertyName]:duplicates
				})

			}
		});
		this.setState(_.assign({},{
			validateResult,
		}));	
	},
	handleAddProperty(value,ops){
		
		let data = this.getFormFieldValue() || this.getInitialState();
		// data = data == "" || data == null || data == undefined ? this.getInitialState() : data;
		data.propertyMap.push({
			propertyName:value,
			values:[""],
		})
		this.updateFormFieldValue(data);
		this.refreshMarixValue();

	},
	handleRemoveProperty(e){
		let key = $(e.currentTarget).data("key");
		let data = this.getFormFieldValue();
		_.remove(data.propertyMap, (o) => o.propertyName === key);
		this.updateFormFieldValue(data);
		this.refreshMarixValue();
	},
	handleAddValue(e){
		let data = this.getFormFieldValue();
		if (data){
			let targetProperty = _.find(data.propertyMap, (o) => o.propertyName === $(e.currentTarget).data("property"));
			let values = targetProperty.values;
			values.push("");
			this.updateFormFieldValue(data);
			this.refreshMarixValue();
			
		}
	},
	handleRemoveValue(e){
		let data = this.getFormFieldValue();
		if (data){
			let targetProperty = _.find(data.propertyMap, (o) => o.propertyName === $(e.currentTarget).data("property"));
			// targetProperty.values.splice(Number($(e.currentTarget).data("index")), 1)
			_.pullAt(targetProperty.values, [Number($(e.currentTarget).data("index"))]);
			this.updateFormFieldValue(data);
			this.refreshMarixValue();
			
		}
	},
	handleValueChange(e){
		let data = this.getFormFieldValue();
		if (data){
			let targetProperty = _.find(data.propertyMap, (o) => o.propertyName === $(e.currentTarget).data("property"));
			let values = targetProperty.values;
			let index = $(e.currentTarget).data("index");
			values[index] = e.currentTarget.value;
			this.refreshMarixValue();
			this.validateValues();
			
		}
	},
	handleInputChange(e){
		let data = this.getFormFieldValue();
		let skey = $(e.target).data('key');
		let target = _.find(data.marixValue, (o) => {
			return o.propertyList.join("|") === skey + ""
		})
		if (target) {
			let key = $(e.target).data('type');
			target[key] = Number(e.target.value);
			this.updateFormFieldValue(data);
			// console.log(data)
		}
		
		
	},
	refreshMarixValue(){
		let data = this.getFormFieldValue();
		if (data){
			let marixValue = _.map(this.caculateMarixValue(), (o) => {
				let target = _.find(data.marixValue, (subobj) => _.isEqual(subobj.propertyList, o));
				if (!target){
					return {
						propertyList:o,
						price:0,
						stock:0,
					}
				}
				return  {
					propertyList:o,
					price:Number(target.price),
					stock:Number(target.stock),
				}
			});
			// data.marixValue = _.assign()
			data.marixValue = marixValue;
			this.updateFormFieldValue(data);
		}
		
	},
	caculateMarixValue(){
		//add marixvalue
		let data = this.getFormFieldValue() || this.getInitialState();
		let tmplist = [];
		_.forEach(data.propertyMap, (property) => {
			if (tmplist.length > 0){
				
				tmplist  = _.map(tmplist, (o) => {
					let sublist = _.map(property.values, (value) => {
						return o.concat(value);
					})	
					return sublist; 
				})

				tmplist = _.flatten(tmplist);
			}
			else {
				tmplist = property.values.length > 0 ?_.map(property.values, (o) => [o]) : [];
			}
		})
		return tmplist;
		// console.log(tmplist);
	},
	renderValue () {
		return renderProertys(false);
	},
	renderOptions(){
		let data = this.getFormFieldValue();
		let selectedOptions = data ? _.map(data.propertyMap, (o) => o.propertyName) : [];
		let options = _.filter(Propertys, (o) => {
			return selectedOptions.indexOf(o) == -1
		})
		return _.map(options, (o) => {
			return <Option key={o} value={o}>{o}</Option>;
		})
	},
	renderMarixValue(){
		let data = this.getFormFieldValue() || this.getInitialState();
		// let propertyKeys = _.map(data.propertyMap, (o) => o.)
		const renderTableCell = (value, row, index) =>{
			const obj = {
			  children: value,
			  props: {},
			};
			if (typeof value === 'object'){
				let key = value.skey.join('|');
				obj.children = <InputNumber
					key={key}
					data-key={key}
					data-type={value.dataIndex}
					defaultValue={value[value.dataIndex]}
					// onChange={this.handleInputChange} 
					onBlur={this.handleInputChange} 
					onPressEnter={this.handleInputChange} 
				 />
			}
			return obj;
		};

		let columns = _.map(data.propertyMap, (o) => {
			return {
				title: o.propertyName,
				dataIndex:o.propertyName,
				render:renderTableCell,
			}
		})
		columns = columns.concat([
			{
				title:'价格',
				dataIndex:'price',
				render:renderTableCell,
			},
			{
				title:'库存',
				dataIndex:'stock',
				render:renderTableCell,
			}
		])
		const datasource = _.map(data.marixValue, (o, index) => {
			let keys = {};
			_.forEach(columns, (column, index) => {
				keys[column.dataIndex] = index < o.propertyList.length ? o.propertyList[index] : _.assign({}, column, { 
					[column.dataIndex]:o[column.dataIndex],
					skey:o.propertyList,
				});
			})
			return keys;
		})
		return (
			<Table 
				columns={columns}
				dataSource={datasource}
				pagination={false}
				size="small"
			>

			</Table>
		)
	},
	renderProertys(canEdited){
		const name = this.getInputName(this.props.path);
		const { getFieldDecorator } = this.props.form;
		const hiddenInput = (
			getFieldDecorator(
				name,
				{
					rules: this.getValidateRules(),
					initialValue:this.getInitValue(),
				}
			)(
				<Input disabled type="hidden" name={name}  />
			)
		);
		let data = this.getFormFieldValue() || this.getInitialState();
		let propertyList = _.map(data.propertyMap, (o) => {
			return <Card 
				key={o.propertyName}
				title={o.propertyName}
				extra={<Icon type="close" data-key={o.propertyName} onClick={this.handleRemoveProperty}></Icon>}
				style={{
					marginTop:15,
				}}
			>
				<Row gutter={16}>
					{_.map(o.values, (value, index) => {
						const suffix = <Icon type="close-circle" data-property={o.propertyName} data-index={index} onClick={this.handleRemoveValue} />;
						let isDuplicate = this.state.validateResult 
											&& this.state.validateResult[o.propertyName] 
											&& this.state.validateResult[o.propertyName].indexOf(value) > -1;
						return <Col key={index} span="8">
							<Form.Item
								validateStatus={isDuplicate && "error"}
								help={isDuplicate && "请勿使用重复值"}
								style={{
									marginBottom:15,
								}}
							>
								<Input 
									onBlur={this.handleValueChange}
									onPressEnter={this.handleValueChange}
									key={value}
									focus={isDuplicate}
									defaultValue={value}
									data-index={index}
									suffix={value && o.values.length > 1 ? suffix : null}
									data-property={o.propertyName}
									
								/>
							</Form.Item>
							
						</Col>
					})}
					<Col span="4">
						<Form.Item>
							<Button 
								type="primary" icon="plus"
								key={"property-" + o.propertyName}
								data-property={o.propertyName} onClick={this.handleAddValue}
								
							>增加值</Button>
						</Form.Item>
					</Col>
				</Row>
				
			</Card>
		});
		
		
		
		return <div>
				{data.propertyMap.length < 3 && <Select ref="add_property" size={this.fieldSize} onChange={this.handleAddProperty}>
						{this.renderOptions()}
					</Select>}
				{propertyList}
			
				
				<div style={{
					marginTop:16,
				}}>
					{data.propertyMap.length > 0 && this.renderMarixValue()}
				</div>
				{hiddenInput}
			</div>
		
		
	},
	renderField () {
		// TODO: This should be natively handled by the Select component
		// var ops = (this.props.numeric) ? this.props.ops.map(function (i) { return { label: i.label, value: i.value}; }) : this.props.ops;
		// return <Input/>
		
		return this.renderProertys(true);

		
	},

});
