import React from 'react';
import PropTypes from 'prop-types'
import ItemsTableCell from '../../components/ItemsTableCell';
import ItemsTableValue from '../../components/ItemsTableValue';

var createReactClass = require('create-react-class');
var MarkdownColumn = createReactClass({
	displayName: 'MarkdownColumn',
	propTypes: {
		col: PropTypes.object,
		data: PropTypes.object,
	},
	renderValue () {
		const value = this.props.data.fields[this.props.col.path];
		return (value && Object.keys(value).length) ? value.md.substr(0, 100) : null;
	},
	render () {
		return (
			<ItemsTableCell>
				<ItemsTableValue field={this.props.col.type}>
					{this.renderValue()}
				</ItemsTableValue>
			</ItemsTableCell>
		);
	},
});

module.exports = MarkdownColumn;
