import React from 'react';
import PropTypes from 'prop-types'
import {
	Link
} from 'react-router-dom';
import ItemsTableCell from '../../components/ItemsTableCell';
import ItemsTableValue from '../../components/ItemsTableValue';
import displayName from 'display-name';

var createReactClass = require('create-react-class');
var NameColumn = createReactClass({
	displayName: 'NameColumn',
	propTypes: {
		col: PropTypes.object,
		data: PropTypes.object,
		linkTo: PropTypes.string,
	},
	renderValue () {
		var value = this.props.data.fields[this.props.col.path];
		if (!value || (!value.first && !value.last)) return '(no name)';
		return displayName(value.first, value.last);
	},
	render () {
		return (
			<div>
				<Link to={this.props.linkTo}>
					{this.renderValue()}
				</Link>
			</div>
		);
	},
});

module.exports = NameColumn;
