import React from 'react';
import PropTypes from 'prop-types'
import ItemsTableCell from '../../components/ItemsTableCell';
import ItemsTableValue from '../../components/ItemsTableValue';
import QRCode from 'qrcode';
import {
	Popover,
	Button,
} from 'antdlib';
var createReactClass = require('create-react-class');
var SelectColumn = createReactClass({
	displayName: 'SelectColumn',
	propTypes: {
		col: PropTypes.object,
		data: PropTypes.object,
		linkTo: PropTypes.string,
	},
	// getValue () {
	// 	const value = this.props.data.fields[this.props.col.path];
	// 	const option = this.props.col.field.ops.filter(i => i.value === value)[0];

	// 	return option ? option.label : null;
	// },
	render () {
		if (!this.props.data.fields[this.props.col.path]) return null;
		const value = this.props.data.fields[this.props.col.path].value;
		// const empty = !value && this.props.linkTo ? true : false;
		let imgurl;
		QRCode.toDataURL(value, function (err, url) {
			imgurl = url;
		})
		let node = <Popover
			content={<img src={imgurl}/>}
			trigger="click"
		>
			<a>
				<img width="24" src={imgurl}/>
			</a>
		</Popover>
		return (
			<ItemsTableCell>
				<ItemsTableValue field={this.props.col.type}>
					{node}
				</ItemsTableValue>
			</ItemsTableCell>
		);
	},
});

module.exports = SelectColumn;
