import React from 'react';
import PropTypes from 'prop-types'
import ItemsTableCell from '../../components/ItemsTableCell';
import ItemsTableValue from '../../components/ItemsTableValue';
import {
	Popover,
	Button,
} from 'antdlib';
import opts, {
	TYPE_TEXT,
	TYPE_BOOLEAN
} from './config'
var createReactClass = require('create-react-class');
var TypeValueColumn = createReactClass({
	displayName: 'TypeValueColumn',
	propTypes: {
		col: PropTypes.object,
		data: PropTypes.object,
		linkTo: PropTypes.string,
	},
	// getValue () {
	// 	const value = this.props.data.fields[this.props.col.path];
	// 	const option = this.props.col.field.ops.filter(i => i.value === value)[0];

	// 	return option ? option.label : null;
	// },
	render () {
		if (!this.props.data.fields[this.props.col.path]) return null;
		const type = this.props.data.fields[this.props.col.path].type;
		let value;
		switch(type){
			case TYPE_TEXT:
				value = this.props.data.fields[this.props.col.path].value;
			break;

			case TYPE_BOOLEAN:
				value = this.props.data.fields[this.props.col.path].value ? "是" : "否";
			break;
		}
		return (
			<ItemsTableCell>
				<ItemsTableValue field={this.props.col.type}>
					{value}
				</ItemsTableValue>
			</ItemsTableCell>
		);
	},
});

module.exports = TypeValueColumn;
